/*
 * Created by SharpDevelop.
 * User: mei
 * Date: 20-3-2008
 * Time: 9:59
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Drawing.Drawing2D;
using System.IO;
using System.Diagnostics;
using System.Collections;
namespace blender_convert
{
	
	struct renameentry
	{
		public string from;
		public string to;
		public string offx;
		public string offy;
		public string offx1;
		public string offy1;
		public string offx2;
		public string offy2;
		
	}
	
	class Program
	{
		ArrayList entries = new ArrayList();
		
		/* Read rename entries */
		void ReadRenameFile(string name)
		{
			FileStream f = new FileStream(name, FileMode.Open);
			TextReader t = new StreamReader(f);
			while (true)
			{
				renameentry entry = new renameentry();
				entry.from = t.ReadLine();
				
				entry.to = t.ReadLine();
				
				string offxt = t.ReadLine();
				string offyt = t.ReadLine();
				if (offxt != null)
				{
				string [] offsets = offxt.Split(',');
				if (offsets.Length == 1)
				{
					entry.offx = offsets[0];
					entry.offx1 = (int.Parse(offsets[0])/2).ToString();
					entry.offx2 = (int.Parse(offsets[0])/4).ToString();
				}
				else if (offsets.Length == 3)
				{
					entry.offx = offsets[0];
					entry.offx1 = offsets[1];
					entry.offx2 = offsets[2];
				}	
				}
				if (offyt != null)
				{
				string []  offsets = offyt.Split(',');
				if (offsets.Length == 1)
				{
					entry.offy = offsets[0];
					entry.offy1 = (int.Parse(offsets[0])/2).ToString();
					entry.offy2 = (int.Parse(offsets[0])/4).ToString();
				}
				else if (offsets.Length == 3)
				{
					entry.offy = offsets[0];
					entry.offy1 = offsets[1];
					entry.offy2 = offsets[2];
				}	
				}
				
				if ((entry.from == null) ||  (entry.to == null)||  (entry.offx == null)||  (entry.offy == null))
					break;
				else
					entries.Add(entry);
			}
			t.Close();
			f.Close();
			
		}
		
		/* check if we know a grf id for this file */
		string getGRFid(string name,out string x, out string y, int zoom)
		{
			for (int i=0; i<entries.Count;i++)
			{
				if (((renameentry) entries[i]).from.ToUpper() == name.ToUpper())
				{
					x="0";
					y="0";
					switch(zoom)
					{
						case 1:
						x=   ((renameentry) entries[i]).offx1;
						y=   ((renameentry) entries[i]).offy1;	
							break;
						case 2:
						x=   ((renameentry) entries[i]).offx2;
						y=   ((renameentry) entries[i]).offy2;	
							break;	
						case 0:
					x=   ((renameentry) entries[i]).offx;
					y=   ((renameentry) entries[i]).offy;
					break;
					};
					return ((renameentry) entries[i]).to;
				}
			}
			x="";
			y="";
			return "fixed_" + name;
		}
		
		/* set all pixels transparent except for pixels colored as mask */
		unsafe void ClearAllExceptMask(ref Image img)
		{
			byte maskBlue= 216;
			byte maskGreen= 152;
			byte maskRed= 72;
			int x,y;
			
			Bitmap bmp = new Bitmap(img);
			BitmapData bmpdat = bmp.LockBits(new Rectangle(0,0,bmp.Width,bmp.Height),ImageLockMode.ReadWrite, PixelFormat.Format32bppArgb);
			Byte * p = (byte *)(void *)bmpdat.Scan0;
			x=0;
			y=0;
			while (y< bmpdat.Height)
			{
	
				   	while (x< bmpdat.Width)
				   	{
				   		/*if ((p[(x+y*bmpdat.Stride/4)*4+0]!=maskBlue)
				   		    || (p[(x+y*bmpdat.Stride/4)*4+1]!=maskGreen)
				   		    || (p[(x+y*bmpdat.Stride/4)*4+2]!=maskRed))
				   			p[(x+y*bmpdat.Stride/4)*4+3]=0;
				   		else
				   			p[(x+y*bmpdat.Stride/4)*4+3]=255;*/
				   		if (p[(x+y*bmpdat.Stride/4)*4+3]>0)
				   			p[(x+y*bmpdat.Stride/4)*4+3]=255;
				   		x++;
				   	}
				   x=0;
				   y++;
			}
			bmp.UnlockBits(bmpdat);
			
			Graphics g = Graphics.FromImage(img);
			g.Clear(Color.FromArgb(0,0,0,0));
			g.DrawImage(bmp,0,0);
			g.Dispose();
			bmp.Dispose();
		}
		
		/* resize image to new size. No .NET function available? */
		Image CropImage(Image img, Rectangle newSize)
		{
			Bitmap bmp = new Bitmap(img);
			Bitmap bmpn = new Bitmap(newSize.Width ,newSize.Height,PixelFormat.Format32bppArgb);
			Graphics g = Graphics.FromImage(bmpn);
			g.DrawImage(bmp,0,0,newSize, GraphicsUnit.Pixel);
			g.Dispose();
			
			bmp.Dispose();
			return bmpn;
		}
		
		/* determine the content rectangle for the input image. Resize both mask and input image */
		bool RemoveTransparentPixels(Image img, Image mask,out Image img_res, out Image mask_res)
		{
			Bitmap bmp = new Bitmap(img);
			
			BitmapData bmpdat = bmp.LockBits(new Rectangle(0,0,bmp.Width,bmp.Height),ImageLockMode.ReadWrite, PixelFormat.Format32bppArgb);
			Rectangle rec = GetImageRect(bmpdat);
			bmp.UnlockBits(bmpdat);
			bmp.Dispose();
			
			if ((rec.Width >0) && (rec.Height>0))
			{
			img_res =CropImage(img,rec);
			mask_res =CropImage(mask,rec);
			return true;
			}
			else
			{
		
				img_res= img;
				mask_res = mask;
			return false;
			}
		}
		
		/* determine content rectangle for an image */
		unsafe Rectangle GetImageRect(BitmapData bmpdat)
		{
			int t=-1,b=-1,l=-1,r=-1,x,y;
	
			Byte * p = (byte *)(void *)bmpdat.Scan0;
			x=0;
			y=0;
			while (((t==-1) || ( b==-1)) && (y< bmpdat.Height))
			{
	
				   	while (x< bmpdat.Width)
				   	{
				   		if ((p[(x+y*bmpdat.Stride/4)*4+3]>3) && (t==-1))
				   			t=y;
				   		if ((p[((bmpdat.Width*bmpdat.Height-1)*4)-(x+y*bmpdat.Width)*4+3]>3) && (b==-1))
				   			b=bmpdat.Height-y;
				   		x++;
				   	}
				   	x=0;
				   	y++;
				
			}
			x=0;
			y=0;
			while (((l==-1) || ( r==-1)) && (x< bmpdat.Width))
			{
	
				   	while (y< bmpdat.Height)
				   	{
				   		if ((p[(x+y*bmpdat.Stride/4)*4+3]>3) && (l==-1))
				   			l=x;
				   		if ((p[((bmpdat.Width*bmpdat.Height-1)*4)-(x+y*bmpdat.Width)*4+3]>3) && (r==-1))
				   			r=bmpdat.Width-x;
				   		
				   		y++;
				   	}
				y=0;   	
				x++;
			}
			Console.WriteLine("Content rectangle (left,top,width,height): " + l.ToString() + ", " + t.ToString() + ", " + (r-l).ToString() + ", " + (b-t).ToString()  );
			return new Rectangle(l,t,r-l,b-t);
		}
		
		Program()
		{
			
			
		}
		
		public static void ShowHelp()
		{
			
			Console.WriteLine("Convert blender output to useable PNG files for OTTD");
			Console.WriteLine("Usage: blender_convert <directory with render output>");
			Console.WriteLine("Example: blender_convert c:\\ottdrenders\\");
					
		}
		
		/* we need to get the mask to png8 */
		public unsafe void makeMaskPaletteBased(Image mask, string outpfilename)
		{
				FreeImageAPI.FreeImage.Initialise(true);
			
			uint handle  = FreeImageAPI.FreeImage.Load(FreeImageAPI.FREE_IMAGE_FORMAT.FIF_PNG,"empty.png",0);
			uint handle2  = FreeImageAPI.FreeImage.Allocate(mask.Width,mask.Height,8,0,0,0);
			FreeImageAPI.FreeImage.SetTransparent(handle2,true);
			
			// Copy palette
			FreeImageAPI.RGBQUAD[] pal =  FreeImageAPI.FreeImage.GetPaletteCopy(handle);
			FreeImageAPI.FreeImage.SetPaletteCopy(handle2,pal);
			
			// Copy transparency
			//IntPtr ptr  = FreeImageAPI.FreeImage.GetTransparencyTable(handle);
			//FreeImageAPI.FreeImage.SetTransparencyTable(handle2,ptr,256);
			
			FreeImageAPI.RGBQUAD col = new FreeImageAPI.RGBQUAD();
			FreeImageAPI.FreeImage.GetBackgroundColor(handle,col);
			FreeImageAPI.FreeImage.SetBackgroundColor(handle2,col);
			
		
			//handle = FreeImageAPI.FreeImage.Rescale(handle,mask.Width,mask.Height,0);
			
			Graphics g = Graphics.FromImage(mask);
			
			for (uint y=0; y< mask.Height;y++)
			for (uint x=0; x< mask.Width;x++)
			{
				byte n;
				if (((Bitmap) mask).GetPixel((int) x,(int) y).A == 255)
				{
					n=200;
				
					
				}
				else
				{
					n=0;
			
				}
				
					
				FreeImageAPI.FreeImage.SetPixelIndex(handle2,x, (uint) mask.Height-y,ref n);
			}
			
			
			
			FileInfo t = new FileInfo("tmp.png");
			t.Delete();
			
			FreeImageAPI.FreeImage.Save(FreeImageAPI.FREE_IMAGE_FORMAT.FIF_PNG,handle2,"tmp.png",0);
			
			String  chunk ="";
			Byte [] c = new Byte[4];

			
			FileStream f2 = new FileStream("tmp.png", FileMode.Open,FileAccess.Read);
			BinaryReader r = new BinaryReader(f2);
			
			int pos =0;
			
			while (!((c[0] == 0x62) && (c[1] == 0x4B) &&(c[2] == 0x47) &&(c[3] == 0x44)  /*"bKGD"*/))
			{
			r.BaseStream.Seek(pos, SeekOrigin.Begin);
			r.Read(c,0,4);
			//chunk = c[0].ToString()+ c[1].ToString()+c[2].ToString()+c[3].ToString();
			pos++;
			};
			pos--;
			
			byte[] buf = new byte[f2.Length];
			r.BaseStream.Seek(0,SeekOrigin.Begin);
			
			
			FileStream f = new FileStream(outpfilename, FileMode.Create,FileAccess.ReadWrite);
			BinaryWriter w = new BinaryWriter(f);
			
			r.Read(buf,0,pos);
			w.Write(buf,0,pos);
			w.Write((byte) 0x74);
			w.Write((byte) 0x52);
			w.Write((byte) 0x4E);
			w.Write((byte) 0x53);
			w.Write((byte) 0x00);
			w.Write((byte) 0x40);
			w.Write((byte) 0xE6);
			w.Write((byte) 0xD8);
			w.Write((byte) 0x66);
			w.Write((byte) 0x00);
			w.Write((byte) 0x00);
			w.Write((byte) 0x00);
			w.Write((byte) 0x01);
			
			r.Read(buf,0,(int) f2.Length-pos);
			w.Write(buf,0,(int)f2.Length-pos);
			r.Close();
			w.Close();
			//w.Close();
			f.Close();
			
			                                                
			                                                //FreeImageAPI.FreeImage.Save(FreeImageAPI.FREE_IMAGE_FORMAT.FIF_GIF,handle,"c:\\ottdrenders\\tst.gif",0);
		
		
		}
		
		
		public string getPart(ref string filename)
		{
			string cur = "";
			int pos = filename.LastIndexOf("_");
			if (pos == -1)
				return "";
			cur = filename.Substring(pos+1,filename.Length-pos-1);
			filename=filename.Substring(0,pos);
			
			
			return cur;
		}
		
		public bool decodeFilename(FileInfo filename,out string imagename,out int zoom,out int frame,out int side,out bool isMask)
		{
			zoom=0;
			frame=0;
			side=0;
			isMask=false;
			
			
			imagename =filename.Name ;
			
			
			if (imagename.Substring(imagename.Length-4,4).ToUpper() != ".PNG")
			{
				return false;
			}
			
			imagename = imagename.Substring(0,imagename.Length-4);
			
			string cur = getPart(ref imagename);
			if (cur[0]!='z')
				return false;
			zoom = int.Parse( cur[1].ToString());
			if (cur.Length==3)
				isMask =true;
			
			cur = getPart(ref imagename);
			side=int.Parse( cur);
			
			cur = getPart(ref imagename);
			frame=int.Parse( cur);
			return true;
		}
		
		/* accepts two filenames */
		public void fixImage(string file_name_render, string file_name_mask)
		{
			
				
			Image img,mask;
			try
			{
				img = Image.FromFile(file_name_render);
			}
			catch
			{
				Console.WriteLine("Unable to load input png file");
				return;
			}
			
			try
			{
				mask = Image.FromFile(file_name_mask);
			}
			catch
			{
				Console.WriteLine("Unable to load mask png file '"+file_name_mask+"'");
				return;
			}
			
			
			if (!RemoveTransparentPixels(img, mask,out img, out mask))
			{
				Console.WriteLine("Skipping file '"+file_name_render+"' because it appears to be empty");
				return;
				
			}
			ClearAllExceptMask(ref mask);
			int zoom = int.Parse( file_name_render.Substring(file_name_render.Length-5,1));
			
			FileInfo f = new FileInfo(file_name_render);
			string x,y;
			string grf = getGRFid(f.Name.Substring(0,f.Name.Length-7),out x, out y,zoom);
				
			DirectoryInfo d= new DirectoryInfo(f.DirectoryName + "\\output\\" );
			if (!d.Exists)
				d.Create();
			
			
			String s =  f.DirectoryName + "\\output\\"  + grf  + "_z" + zoom.ToString() + ".png" ;
			f = new FileInfo(file_name_mask);	
			String s2 =  f.DirectoryName + "\\output\\" +grf + "_z" + zoom.ToString() + "m.png" ;
			

			
			
			img.Save(s);
			
			Process p = new Process();
			p.StartInfo.FileName= "pngcodec";
			Console.WriteLine("pngcodec r "  + s +" x_offs=" + x.ToString() + " y_offs=" + y.ToString());
			p.StartInfo.Arguments = "r "  + s +" x_offs=" + x.ToString() + " y_offs=" + y.ToString();
			p.Start();
			//mask.Save(s + "_fixed_z0m.png");
			
			//makeMaskPaletteBased(s + "_fixed_z0m.png");
			makeMaskPaletteBased(mask,s2);
			Console.WriteLine("Files written as ");
			Console.WriteLine(s );
			Console.WriteLine(s2 );
			
			
		}
		
		public static void Main(string[] args)
		{
			if (args.Length != 1)
			{
				
				ShowHelp();
				return;
			}	
			
			
			if (args[0] == "--help")
			{
				
				ShowHelp();
				return;
			}
				
			
			if (args[0].Substring( args[0].Length)!= "\\")
			    args[0]= args[0] + "\\";
			
			DirectoryInfo d;	
			Program p = new Program();
			p.ReadRenameFile( args[0] + "\\rename.txt");
			try
			{
			d = new DirectoryInfo(args[0]);
				
			}
			catch
			{
				Console.WriteLine("Parameter 1 is not a valid directory");
				return;
			}
			
			
			Console.WriteLine("Converting files...");
			
			/* for each file, go fix it */
			foreach (FileInfo fi in d.GetFiles("*_z*.png"))
			{
				if ((fi.FullName.IndexOf("fixed_") == -1)&& ( fi.FullName.Substring(fi.FullName.Length-5).ToLower()!= "m.png"))
				{
					string mask_file = fi.FullName.Substring(0,fi.FullName.Length-4) +"m.png";
					p.fixImage(fi.FullName,mask_file);
				}
			}
			
			//p.fixImage(args[0],args[1]);
			
			
			
			Console.WriteLine("Press any key to continue . . . ");
			Console.ReadKey(true);
		}
	}
}
