/*
 * Gemaakt met SharpDevelop.
 * Gebruiker: Bart
 * Datum: 21-3-2008
 * Tijd: 13:41
 * 
 * Dit sjabloon wijzigen: Extra | Opties |Coderen | Standaard kop bewerken.
 */

using System;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;
using System.Runtime.InteropServices ;
namespace blender_convert
{
	/// <summary>
	/// Description of png_writer.
	/// </summary>
	public class png_writer
	{
		
		byte[] pngsignature = {137, 80, 78, 71, 13, 10, 26, 10};
		ulong[] crc_table = new ulong[256];
		bool crc_table_computed = false;

		[StructLayout(LayoutKind.Sequential)]
		struct pngheader
		{
			public uint width;
			public uint height;
			public byte bit_depth;
			public byte color_type;
			public byte compression;
			public byte filter;
			public byte interlace;
		}
		
		
		public png_writer()
		{
		}
		
		public void save()
		{
			FileStream f = new FileStream("c:\\test.png", FileMode.Create);
			BinaryWriter wr = new BinaryWriter(f);
			wr.Write(pngsignature);
			
			
			pngheader head = new pngheader();
			head.width = 5;
			head.height=5;
			head.bit_depth=8;
			head.color_type=3;
			head.compression=0;
			head.filter=0;
			head.interlace=0;
			
			byte[] buff = new byte[Marshal.SizeOf(head)]; 

			IntPtr ptr = Marshal.AllocHGlobal(Marshal.SizeOf(head)); 
			Marshal.StructureToPtr(head,ptr,false);
			Marshal.Copy(ptr,  buff,0, buff.Length); 
			
			
			writeChuck(wr,"IHDR",buff);
			
			byte[] palette_data = new byte[768];
			FileStream pal_file = new FileStream("ottd.pal", FileMode.Open);
			BinaryReader r = new BinaryReader(pal_file);
			r.Read(palette_data,0,palette_data.Length);
			r.Close();
			pal_file.Close();
			
			writeChuck(wr,"PLTE",palette_data);
			
			wr.Close();
			f.Close();
		}
		
		void writeChuck(BinaryWriter wr,string header, Byte[] data)
		{
			wr.Write(data.Length);
			wr.Write(header.ToCharArray());
			wr.Write(data);
			
			wr.Write(crc(data,data.Length));
			
		}
		
		  
   
   /* Make the table for a fast CRC. */
   void make_crc_table()
   {

   	
     ulong c;

     int n, k;

     
     for (n = 0; n < 256; n++) {
       c = (ulong) n;
       for (k = 0; k < 8; k++) {
      
       	if ((c & ((ulong) 1))==1)
           c = 0xedb88320L ^ (c >> 1);
         else
           c = c >> 1;
       }
       crc_table[n] = c;
     }
     crc_table_computed = true;
   }
  

   /* Update a running CRC with the bytes buf[0..len-1]--the CRC
      should be initialized to all 1's, and the transmitted value
      is the 1's complement of the final running CRC (see the
      crc() routine below). */
   
   ulong update_crc(ulong crc, byte[] buf,int len)
   {
     ulong c = crc;
     int n;
   
     if (!crc_table_computed)
       make_crc_table();
     for (n = 0; n < len; n++) {
       c = crc_table[(c ^ buf[n]) & 0xff] ^ (c >> 8);
     }
     return c;
   }
   
   /* Return the CRC of the bytes buf[0..len-1]. */
   ulong crc(byte[] buf, int len)
   {
     return update_crc(0xffffffffL, buf, len) ^ 0xffffffffL;
   }


		
	}
}
